////////////////////////////////////////////////////////////////////////
// Breeze Website Builder
// Copyright Silver Dolphin Solutions, LLC, Edward Lemmers, P.E.
// For licensing, see license.txt.
// Created: 12/30/2018
//
var browser = BrowserDetect.browser;
var browser_version = BrowserDetect.version;
var nic_editor1;

if ((browser == "Explorer") && (browser_version <= 7))
	var inherit = "";
else
	var inherit = "inherit";
	
var param_array = {'popup_msg_type' : 1, 'status_msg' : '', 'popup_timeout' : -1};
var popup_msg = new PopupMsg(param_array);
	
//////////////////////////////////////////////////////////////////////////////////////
function OpenHelpWindow()
{
	window.open("http://breezewebsitebuilder.com/docs/cms/help.html#plugins", "Help", "scrollbars=1,resizable=1,status=0,toolbar=0,menubar=0,location=0,height=700,width=800");
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
function ElExists(el)
{
	if ((document.getElementById(el) != null) && (typeof document.getElementById(el) != "undefined"))
		return true;
	else
		return false;
}

//////////////////////////////////////////////////////////////////////////////////////////////
function SelectLocation(location_id)
{
	var params = "";
	
	popup_msg.popup_msg_type = 1;
	popup_msg.status_msg = CALENDAR_EVENTS_RETRIEVING_LOCATION_MSG;
	popup_msg.popup_timeout = -1;
	popup_msg.top_offset = 0;
	popup_msg.left_offset = 500;
	popup_msg.ShowPopupMsg();
	
	document.getElementById("edit_table").style.display = "table";
	document.getElementById("select_location_row_1").style.display = "none";
	document.getElementById("select_location_row_2").style.display = "none";
	document.getElementById("select_location_row_3").style.display = "table-cell";
	document.getElementById("select_location_row_3").innerHTML = MANAGE_LOCATION_EDIT_LOCATION + ":";
	document.getElementById("filter_table").style.display = "none";
	document.getElementById("hr1").style.display = "none";
	document.getElementById("delete_btn").style.display = "block";
	
	if (!nic_editor1)
		nic_editor1 = new nicEditor({iconsPath : 'js/nicEditorIcons.gif', fullPanel : true}).panelInstance('location_description');
		
	var xmlhttp;
	xmlhttp = getXmlHttpRequestObject();
	if (xmlhttp.readyState == 4 || xmlhttp.readyState == 0)
	{
		xmlhttp.open("POST","get_location.php",true);
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
		xmlhttp = UpdateMessage(xmlhttp, "SelectLocation");

		params = "location_id=" + location_id;
		xmlhttp.send(params);
	}
	
	document.getElementById("save_btn").style.display = "block";
	document.getElementById("delete_btn").style.display = "block";
}

function UpdateMessage(xmlhttp, source)
{
	xmlhttp.onreadystatechange=function()
	{
		if (xmlhttp.readyState==4)
		{
			if (xmlhttp.responseText.length > 0)
				response = xmlhttp.responseText;
			else
				response = RECORD_NOT_FOUND;
//alert(response);
			if (source == "SelectLocation")	{
				PopulateLocation(response);
				status_msg = MANAGE_LOCATION_POPULATE_LOCATION_COMPLETED_MSG;
			}
			else if (source == "SaveLocation")	{
				mTimer = setTimeout("SelectLocation(" + response + ");", 10);
				status_msg = "Save location completed.";
			}
			else if (source == "Filter")	{
				FilterLocationsList(response);
				status_msg = "Locations list updated.";
			}
				
			popup_msg.popup_timeout = 2000;
		}
		else if (xmlhttp.readyState==1)
			status_msg = QUERY_READY_TO_SEND;
		else if (xmlhttp.readyState==2)
			status_msg = QUERY_SENT;
		else if (xmlhttp.readyState==3)
			status_msg = QUERYING;
		
		popup_msg.status_msg = status_msg;
		popup_msg.ShowPopupMsg();
	}
	return (xmlhttp);
}

function PopulateLocation(location_rcd)
{
	popup_msg.status_msg = CALENDAR_EVENTS_POPULATING_LOCATION_MSG;
	popup_msg.popup_timeout = 2000;
	popup_msg.ShowPopupMsg();
	
	var JSON_row = JSON.parse(location_rcd);
		
	var location_id = parseInt(JSON_row.location_id);
	var select_location_el = document.getElementById('select_location');
	var select_location_options = select_location_el.options;
	var select_location_arr = new Array();
	for (var i = 0; i < select_location_options.length; i++)
		select_location_arr[i] = parseInt(select_location_options[i].value);
	if (select_location_arr.indexOf(location_id) < 1)
	{
		var opt = document.createElement("option");
		opt.text = JSON_row.location_name + " - " + JSON_row.location_city;
		opt.value = location_id;
		select_location_el.appendChild(opt);
		select_location_el.selectedIndex = select_location_el.options.length - 1;
	}
	else
		select_location_el.selectedIndex = select_location_arr.indexOf(location_id);
	document.getElementById("location_id").value = location_id;
	
	location_name = JSON_row.location_name.replace("&#39;", "'");
	document.getElementById("location_name").value = location_name;
	document.getElementById("address").value = JSON_row.address;
	document.getElementById("address2").value = JSON_row.address2;
	document.getElementById("city_select").value = JSON_row.city;
	document.getElementById("city").value = JSON_row.city;
	document.getElementById("state_select").value = JSON_row.state;
	document.getElementById("state").value = JSON_row.state;
	document.getElementById("country_select").value = JSON_row.country;
	document.getElementById("country").value = JSON_row.country;
	document.getElementById("postal_code").value = JSON_row.postal_code;
	document.getElementById("phone").value = JSON_row.phone;
	document.getElementById("phone2").value = JSON_row.phone2;
	document.getElementById("fax").value = JSON_row.fax;
	document.getElementById("website").value = JSON_row.website;
	document.getElementById("web_link_text").value = JSON_row.web_link_text;
	document.getElementById("email").value = JSON_row.email;
	document.getElementById("location_description").value = JSON_row.location_description;
	nicEditors.findEditor('location_description').setContent(JSON_row.location_description);
	document.getElementById("location_status").value = JSON_row.location_status;
	document.getElementById("location_owner").value = JSON_row.location_owner;
		
	var checkboxes = document.getElementById('location_categories_cell').getElementsByTagName('input');
	for (i = 0; i < checkboxes.length; i++) {
		checkboxes[i].checked = false;
	}
	if ((JSON_row.location_categories != null) && (JSON_row.location_categories != ""))
	{
		var category_id;
		var location_categories = JSON_row.location_categories.split(",");
		for (var z in location_categories)
		{
			category_id = location_categories[z] + "_location_cat";
			if (ElExists(category_id))
				document.getElementById(category_id).checked = true;
		}
	}
		
	if (JSON_row.location_active == 1)
		document.getElementById("location_active").checked = true;
	else
		document.getElementById("location_active").checked = false;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
function SaveLocation(bClose)
{
	if (!CheckFields())
		return;
		
	var params = "";
	var categories = "";
	var comma = "";
	var el_name, category;
	
	popup_msg.popup_msg_type = 1;
	popup_msg.status_msg = MANAGE_LOCATION_SAVING_LOCATION_MSG;
	popup_msg.popup_timeout = -1;
	popup_msg.top_offset = 0;
	popup_msg.left_offset = 500;
	popup_msg.ShowPopupMsg();
	
	var checkboxes = document.getElementById('location_categories_cell').getElementsByTagName('input');
	for (var i = 0; i < checkboxes.length; i++) {
		if (checkboxes[i].checked == true)	{
			el_name = checkboxes[i].getAttribute("name");
			category = el_name.replace("_location_cat", "");
			categories = categories + comma + category;
			comma = ",";
		}
	}
	document.getElementById("location_categories").value = categories;
		
	var xmlhttp;
	xmlhttp = getXmlHttpRequestObject();
	if (xmlhttp.readyState == 4 || xmlhttp.readyState == 0)
	{
		xmlhttp.open("POST","save_location.php",true);
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
		xmlhttp = UpdateMessage(xmlhttp, "SaveLocation");

		var location_id = document.getElementById("select_location").value;
		if (location_id == "")
			location_id = -1;
		params = "location_id=" + location_id;
		var location_name = document.getElementById("location_name").value
		location_name = location_name.replace(/\'/g, "&#39;");
		location_name = location_name.replace(/\&/g, "AMPERSAND");
		params = params + "&location_name=" + location_name;
		params = params + "&address=" + document.getElementById("address").value;
		params = params + "&address2=" + document.getElementById("address2").value;
		params = params + "&city=" + document.getElementById("city").value;
		params = params + "&state=" + document.getElementById("state").value;
		params = params + "&country=" + document.getElementById("country").value;
		params = params + "&postal_code=" + document.getElementById("postal_code").value;
		params = params + "&phone=" + document.getElementById("phone").value;
		params = params + "&phone2=" + document.getElementById("phone2").value;
		params = params + "&fax=" + document.getElementById("fax").value;
		params = params + "&website=" + document.getElementById("website").value;
		params = params + "&web_link_text=" + document.getElementById("web_link_text").value;
		params = params + "&email=" + document.getElementById("email").value;
		var location_description = document.getElementById("location_description").value
		location_description = location_description.replace(/\&/g, "AMPERSAND");
		params = params + "&location_description=" + location_description;
		params = params + "&location_status=" + document.getElementById("location_status").value;
		params = params + "&location_categories=" + categories;
		params = params + "&location_owner=" + document.getElementById("location_owner").value;
		if (document.getElementById("location_active").checked == true)
			params = params + "&location_active=1";
		else
			params = params + "&location_active=0";
		
		xmlhttp.send(params);
	}
	
	if (bClose)
		CloseEditForm();
}

/////////////////////////////////////////////////////////////////////////////////////////////////
function Filter()
{
	//document.getElementById("frmFilter").submit();
	popup_msg.popup_msg_type = 1;
	popup_msg.status_msg = MANAGE_LOCATION_FILTERING_LOCATIONS_MSG;
	popup_msg.popup_timeout = 2000;
	popup_msg.top_offset = 0;
	popup_msg.left_offset = 500;
	popup_msg.ShowPopupMsg();
	
	var xmlhttp;
	xmlhttp = getXmlHttpRequestObject();
	if (xmlhttp.readyState == 4 || xmlhttp.readyState == 0)
	{
		xmlhttp.open("POST","filter_locations.php",true);
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
		xmlhttp = UpdateMessage(xmlhttp, "Filter");

		params = "filter_city=" + document.getElementById("filter_city").value;
		if (document.getElementById("show_pending").checked == true)
			params = params + "&show_pending=1";
		else
			params = params + "&show_pending=0";
		
		xmlhttp.send(params);
	}
}

function FilterLocationsList(filtered_locations)
{
	var row_delim = "::::";
	var col_delim = ":::";
	
	var filtered_locations_rows = filtered_locations.split(row_delim);
	var filtered_locations_cols;
	var select_location_el = document.getElementById('select_location');
	select_location_el.options.length = 0;
	select_location_el.options[select_location_el.options.length] = new Option("-not selected-", "");
	for (var i = 0; i < filtered_locations_rows.length; i++)
	{
		filtered_locations_cols = filtered_locations_rows[i].split(col_delim);
		select_location_el.options[select_location_el.options.length] = new Option(filtered_locations_cols[1] + " - " + filtered_locations_cols[2], filtered_locations_cols[0]);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////
function DeleteConfirm()
{
	popup_msg.popup_timeout = -1;
	popup_msg.top_offset = 0;
	popup_msg.left_offset = 300;
	popup_msg.popup_msg_type = 3;
	popup_msg.popup_btn_cnt = 2;
	popup_msg.popup_msg_cell = CALENDAR_EVENTS_DELETE_EVENT_CONFIRM_1_MSG + " <b>" + document.getElementById("location_name").value + "</b> " + MANAGE_LOCATION_DELETE_LOCATION_MSG_2;
	popup_msg.popup_button_2_span = YES_WORD;
	popup_msg.popup_button_1_span = NO_WORD;
	popup_msg.ShowPopupMsg();
	document.getElementById("popup_button_2_span").onclick = function () { DeleteLocation(); };
	document.getElementById("popup_button_1_span").onclick = function () { popup_msg.HidePopupMsg(); };
	popup_msg.popup_timeout = -1;
}

function DeleteLocation()
{
	popup_msg.popup_msg_type = 1;
	popup_msg.status_msg = MANAGE_LOCATION_DELETING_LOCATION_MSG;
	popup_msg.popup_timeout = 2000;
	popup_msg.top_offset = 0;
	popup_msg.left_offset = 500;
	popup_msg.ShowPopupMsg();
	
	var location_id = document.getElementById("select_location").value;
	popup_msg.HidePopupMsg();
	var url = "delete_location.php?location_id=" + location_id + "&filter_city=" + filter_city;
	window.location = url;
}

/////////////////////////////////////////////////////////////////////////////////////////////////
function CreateLocation()
{
	popup_msg.popup_msg_type = 1;
	popup_msg.status_msg = MANAGE_LOCATION_CLEARING_FORM_NOW_LOCATION_MSG;
	popup_msg.popup_timeout = 2000;
	popup_msg.top_offset = 0;
	popup_msg.left_offset = 500;
	popup_msg.ShowPopupMsg();
	
	document.getElementById("frmLocation").reset();
	
	document.getElementById("cloak_div").style.display = "block";
	document.getElementById("select_location_row_1").style.display = "none";
	document.getElementById("select_location_row_2").style.display = "none";
	document.getElementById("select_location_row_3").style.display = "table-cell";
	document.getElementById("select_location_row_3").innerHTML = "Create New Location:";
	document.getElementById("filter_table").style.display = "none";
	document.getElementById("save_btn").style.display = "block";
	document.getElementById("delete_btn").style.display = "block";
	document.getElementById("hr1").style.display = "none";
	document.getElementById("edit_table").style.display = "table";
	document.getElementById("delete_btn").style.display = "none";
	document.getElementById("location_status").value = 0;
	document.getElementById("location_active").checked = true;
	
	if (!nic_editor1)
		nic_editor1 = new nicEditor({iconsPath : 'js/nicEditorIcons.gif', fullPanel : true}).panelInstance('location_description');
	else
		nicEditors.findEditor('location_description').setContent("");
}

function EditLocation()
{
	document.getElementById("frmLocation").reset();
	
	document.getElementById("cloak_div").style.display = "block";
	document.getElementById("select_location_row_1").style.display = inherit;
	document.getElementById("select_location_row_2").style.display = inherit;
	document.getElementById("select_location_row_3").style.display = "none";
	document.getElementById("business_name_cell").style.maxWidth = "300px";
	document.getElementById("filter_table").style.display = "table";
	document.getElementById("save_btn").style.display = "block";
	document.getElementById("delete_btn").style.display = "block";
	document.getElementById("hr1").style.display = inherit;
	document.getElementById("edit_table").style.display = "none";
}

function PopulateCategories(cat_type)
{
	var where = "";
	if (cat_type == "event")
		where = "event_type = 1";
	else if (cat_type == "location")
		where = "location_type = 1";
		
	$.post( "../../get_rows.php", { table: "event_location_categories", where: where, order_by: "sort_order", no_prefix: 0 } ).done(function( data ) { CompletePopulateCategories(data, cat_type); } ) ;
}
function CompletePopulateCategories(data, cat_type)
{
	var rows = new Array();
	var html = "";
	var cat_name_suffix, target_cell, categories_heading_row, categories_row;
	if (cat_type == "location")	{
		cat_name_suffix = "_location_cat";
		target_cell = "location_categories_cell";
		categories_heading_row = "location_categories_heading_row";
		categories_row = "location_categories_row";
	}
	else	{
		cat_name_suffix = "_event_cat";
		target_cell = "event_categories_cell";
		categories_heading_row = "event_categories_heading_row";
		categories_row = "event_categories_row";
	}
	
	rows = data.split("@@@@@");
	if (rows[0] == "-no data-")	{
		popup_msg.status_msg = CALENDAR_EVENTS_NO_CATEGORIES_FOUND_MSG;
		popup_msg.top_offset = 100;
		popup_msg.left_offset = 320;
		popup_msg.popup_msg_type = 2;
		popup_msg.popup_timeout = 2000;
		popup_msg.ShowPopupMsg();
		
		if (ElExists(categories_heading_row))
			document.getElementById(categories_heading_row).style.display = "none";
		document.getElementById(categories_row).style.display = "none";
	}
	else
	{
		for (var i in rows)
		{
			var JSON_row = JSON.parse(rows[i]);
			html = html + "<div class='category_chkbox'><input id='" + JSON_row.category + cat_name_suffix + "' name='" + JSON_row.category + cat_name_suffix + "' type='checkbox' value='" + JSON_row.category + "' /> " + JSON_row.category_string + "</div>\n";
		}

		document.getElementById(target_cell).innerHTML = html;
		
		if (ElExists(categories_heading_row))
			document.getElementById(categories_heading_row).style.display = "table-row";
		document.getElementById(categories_row).style.display = "table-row";
	}
}

//////////////////////////////////////////////////////////////////////////////////
function InitializeForm()
{
	document.getElementById("save_btn").style.display = "none";
	document.getElementById("delete_btn").style.display = "none";
	document.getElementById("cloak_div").style.display = "none";
	document.getElementById("edit_table").style.display = "none";
}

function InitializeConsole()
{
	popup_msg.HidePopupMsg();
	InitializeForm();
	PopulateCategories("location");
}

function CloseEditForm()
{
	document.getElementById("cloak_div").style.display = "none";
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
function CheckFields()
{
	if (document.getElementById("location_name").value == "")	{
		alert(MANAGE_LOCATION_PLEASE_ENTER_NAME_MSG);
		return false;
	}
//	if (nicEditors.findEditor('location_description').getContent() == "")	{
//		alert("Please enter a description for your location.");
//		return false;
//	}
//	else
		document.getElementById("location_description").value = nicEditors.findEditor('location_description').getContent();
	
	if (document.getElementById("address").value == "")	{
		alert(MANAGE_LOCATION_PLEASE_ENTER_ADDRESS_MSG);
		return false;
	}
	if (document.getElementById("city").value == "")	{
		alert(MANAGE_LOCATION_PLEASE_ENTER_CITY_MSG);
		return false;
	}
	if (document.getElementById("postal_code").value == "")	{
		alert(MANAGE_LOCATION_PLEASE_ENTER_ZIP_MSG);
		return false;
	}
	return true;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////
function ResizeWorkspace(mainWidth, mainHeight, menuWidth, headerHeight) {

}

function DisplayNotSavedMessage(btn)	{
	// Needed to complete call when deleting unsaved page.
	window.parent.SetWorkSavedNotSaved(true);
	window.parent.next_btn = btn;
	window.parent.DoNextClick();
}